# Generated by Django 3.2.13 on 2022-07-18 09:24

from django.db import migrations, models
import django.db.models.deletion
import django_mysql.models


def migrate_notification(apps, schema_editor):
    Profile = apps.get_model('profiles', 'Profile')
    NotificationFilter = apps.get_model('profiles', 'NotificationFilter')
    for profile in Profile.objects.all():
        new_filter = NotificationFilter.objects.create(name="service",
                                          profile=profile)
        new_filter.services.add(*list(profile.subscribed_services_notification.all()))


class Migration(migrations.Migration):

    dependencies = [
        ('service_catalog', '0008_auto_20220718_1124'),
        ('profiles', '0004_quota_quotabinding'),
    ]

    operations = [
        migrations.CreateModel(
            name='NotificationFilter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('request_states', django_mysql.models.ListCharField(models.CharField(max_length=50), max_length=764, size=15)),
                ('instance_states', django_mysql.models.ListCharField(models.CharField(max_length=50), max_length=764, size=15)),
                ('when', models.TextField(blank=True, null=True)),
                ('operations', models.ManyToManyField(blank=True, related_name='notification_filters', related_query_name='notification_filter', to='service_catalog.Operation')),
                ('profile', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='notification_filters', related_query_name='notification_filter', to='profiles.profile')),
                ('services', models.ManyToManyField(blank=True, related_name='notification_filters', related_query_name='notification_filter', to='service_catalog.Service')),
            ],
        ),
        migrations.RunPython(migrate_notification),
        migrations.RemoveField(
            model_name='profile',
            name='subscribed_services_notification',
        ),
    ]
